#include <iostream.h>
#include <list.h>

class shape {
public:
  virtual void draw() { cout << "shape::draw\n"; }
  virtual ~shape() { cout << "~shape\n"; }
};

class circle : public shape {
public:
  void draw() { cout << "circle::draw\n"; }
  ~circle() { cout << "~circle\n"; }
};

class square : public shape {
public:
  void draw() { cout << "square::draw\n"; }
  ~square() { cout << "~square\n"; }
};

class triangle : public shape {
public:
  void draw() { cout << "triangle::draw\n"; }
  ~triangle() { cout << "~triangle\n"; }
};

void main() {
  list<shape*> shapes;
  shapes.push_back(new circle);
  shapes.push_back(new square);
  shapes.push_back(new triangle);
  list<shape*>::iterator i;
  for(i = shapes.begin(); i != shapes.end(); i++)
    (*i)->draw();
  for(i = shapes.begin(); i != shapes.end(); i++)
    delete *i;
}