//: STATDEST.CPP -- Static object destructors
#include <fstream.h>
ostream& out = cout;

class obj {
  char c; // Identifier
public:
  obj(char C) : c(C) {
    out << "obj::obj() for " << c << endl;
  }
  ~obj() {
    out << "obj::~obj() for " << c << endl;
  }
};

obj A('A'); // Global (static storage)
// Constructor & destructor always called

void f() {
  static obj B('B');
}

void g() {
  static obj C('C');
}

main() {
  out << "inside main()" << endl;
  g();
  f(); 
  out << "leaving main()" << endl;
}
