#include <iostream.h>
#include <strstrea.h>

class Char {
  char c;
public:
  Char(char C) : c(C) {}
  void set(char C) { c = C; }
  char read() const { return c; }
  Char& operator=(const Char& C) {
    c = C.c;
    return *this;
  }
  friend ostream& 
    operator<<(ostream& os, const Char& C) {
      return os << C.c;
  }
  friend istream&
    operator>>(istream& is, Char& C) {
      return is >> C.c;
  }
};

void main() {
  Char C('x');
  cout << C << endl;
  istrstream in("abc");
  in >> C;
  cout << C << endl;
  Char D = C = 'z';
  cout << (C = D) << endl;
}
  